> For the complete documentation index, see [llms.txt](https://docs.hackle.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hackle.io/development-guide/ios/ios-optout.md).

# 옵트아웃

옵트아웃이 활성화되면 SDK는 모든 이벤트 전송을 중단합니다.

## 초기화 시 설정

{% tabs %}
{% tab title="Swift" %}

```swift
let config = HackleConfigBuilder()
    .optOutTracking(true)
    .build()

Hackle.initialize(sdkKey: YOUR_APP_SDK_KEY, config: config) {
    // SDK ready to use.
}
```

{% endtab %}

{% tab title="Objective-C" %}

```objectivec
HackleConfigBuilder *builder = [[HackleConfigBuilder alloc] init];
[builder optOutTracking:YES];
HackleConfig *config = [builder build];

[Hackle initializeWithSdkKey:@"YOUR_APP_SDK_KEY" config:config completion:^{
    // SDK ready to use.
}];
```

{% endtab %}
{% endtabs %}

## 런타임 옵트아웃 제어

{% tabs %}
{% tab title="Swift" %}

```swift
hackleApp.setOptOutTracking(optOut: true)   // activate
hackleApp.setOptOutTracking(optOut: false)  // deactivate
let isOptOut = hackleApp.isOptOutTracking   // query (property, not method)
```

{% endtab %}

{% tab title="Objective-C" %}

```objectivec
[hackleApp setOptOutTrackingWithOptOut:YES];
[hackleApp setOptOutTrackingWithOptOut:NO];
BOOL isOptOut = hackleApp.isOptOutTracking;
```

{% endtab %}
{% endtabs %}

## 영속성 관리

{% hint style="warning" %}
런타임에 변경된 옵트아웃 상태는 앱 재시작 시 초기화 Config에 설정된 값으로 리셋됩니다.

앱 재시작 후에도 상태를 유지하려면 직접 저장 및 복원 로직을 구현해야 합니다.
{% endhint %}

{% tabs %}
{% tab title="Swift" %}

```swift
func saveOptOutState(_ optOut: Bool) {
    UserDefaults.standard.set(optOut, forKey: "hackle_opt_out")
    hackleApp.setOptOutTracking(optOut: optOut)
}

func getOptOutConfig() -> HackleConfig {
    let optOut = UserDefaults.standard.bool(forKey: "hackle_opt_out")
    return HackleConfigBuilder()
        .optOutTracking(optOut)
        .build()
}
```

{% endtab %}

{% tab title="Objective-C" %}

```objectivec
- (void)saveOptOutState:(BOOL)optOut {
    [[NSUserDefaults standardUserDefaults] setBool:optOut forKey:@"hackle_opt_out"];
    [hackleApp setOptOutTrackingWithOptOut:optOut];
}

- (HackleConfig *)getOptOutConfig {
    BOOL optOut = [[NSUserDefaults standardUserDefaults] boolForKey:@"hackle_opt_out"];
    HackleConfigBuilder *builder = [[HackleConfigBuilder alloc] init];
    [builder optOutTracking:optOut];
    return [builder build];
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hackle.io/development-guide/ios/ios-optout.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
